/*****************************************************************************
 *               Copyright (C) 2011, Huawei Tech. Co., Ltd.
 *                           ALL RIGHTS RESERVED
******************************************************************************/
/**\file route6cmsapi.h
  *
  *\copyright 2007-2020Ϊ޹˾
  *\author x00192803
  *\date  2012-1-15
*/

/******************************************************************************
  Ȩ  : 2007-2020Ϊ޹˾
      : route6cmsapi.h
        : d00107688
        : 1.0
    : 2009-11-9
        : ·API
  б  :

  ʷ¼      :
   1.       : 2009-11-9
            : d00107688
     ޸   : ɳ

*********************************************************************************/

#ifndef __ROUTE6_CMS_API_H__
#define __ROUTE6_CMS_API_H__

#ifdef __cplusplus
#if __cplusplus
extern "C" {
#endif /* __cpluscplus */
#endif /* __cpluscplus */

#ifdef ATP_DEBUG
#define ATP_ROUTE6_DEBUG(format,arg...) printf("\r\n"format"FILE[%s] FUNC[%s] LINE[%d] \r\n",## arg,__FILE__,__func__,__LINE__) 
#define ATP_ROUTE6_ERROR(format,arg...) printf("\r\n"format"FILE[%s] FUNC[%s] LINE[%d] \r\n",## arg,__FILE__,__func__,__LINE__)
#else
#define ATP_ROUTE6_DEBUG(format,arg...)
#define ATP_ROUTE6_ERROR(format,arg...) printf("\r\n"format"FILE[%s] LINE[%d] \r\n",## arg,__FILE__,__LINE__)
#endif

//!mark tableʼֵ
#define BIND6_FWMARKRULEDEV_TABLE_START  200   

//!IPDEVʹõĲ·ɱС 
#define BIND6_IPRULEDEV_TABLE_START     100
//!IPDEVʹõĲ·ɱ 
#define BIND6_IPRULEDEV_TABLE_END    120

//!ԴַʱԴַ
#define BIND6_IP_LENGTH              64 
//!PVCNAME󳤶
#define BIND6_PVCNAME_LENGTH         32 
//!ʹIP·ɱĿ
#define BIND6_TABLE_IPRULE_MAX_NUM   32   
//!·ɱ
#define BIND6_TABLE_MAX_NUM          256   
//!󶨱ʶλʶѾ󶨡
#define BIND6_TRUE                   1 
//!󶨱ʶλʶδ󶨡
#define BIND6_FALSE                 0

//!ֵ֧LANĿ
#ifdef SUPPORT_ATP_WLAN
#define BIND6_MAXLANNUM              8        
#else
#define BIND6_MAXLANNUM              4        
#endif

/* ǰ׺ */
#define ROUTE6_WAN_PREFIXLIST_LEN (128 + 4)
/* <DTS2013022804321 wanglong 20130312 begin */
/* start added by c00177661 for ·mark */
#define ROUTE6_BRDGE_BIND_MARK                  "0x2%d000000"  //ipv6Űmark
/* end added by c00177661 for ·mark */
/* DTS2013022804321 wanglong 20130312 end> */
//!\brief Դip·Ϣṹ
/*!
 *
 */
struct Bind6IpRuleMap
{
    VOS_UINT32 ulTableId;                       /*!< ʹõĲ·ɱ */
    VOS_CHAR   pcPvcName[BIND6_PVCNAME_LENGTH];  /*!< ԴIPַ󶨵PVC֣ؼ֡ */
    VOS_BOOL ulUsedFlag;                      /*!< ʾṹݰ󶨹 */
    VOS_CHAR   pcSrcIp[BIND6_IP_LENGTH];         /*!< ԴIPַ󶨵Դַ */
    VOS_CHAR   pcGateway[BIND6_IP_LENGTH];       /*!< һַ */
    VOS_CHAR   pcRaPrefix[ROUTE6_WAN_PREFIXLIST_LEN];/*!< wanַraɵprefix OnLink */
};

//!\brief Դip·ɹ״̬ṹ
/*!
 *
 */
typedef enum tagATP_BIND6_IPRULE_FLAG
{
    ATP_BIND6_IPRULE_UNUSED = 0,
    ATP_BIND6_IPRULE_USED = 1
} ATP_BIND6_IPRULE_FLAG_EN;

/*!
  \brief һŰ󶨶WANʱɾĳĬ·ɵWANҪWANΪµĬ·
  \param[in]  pszWANInfPath: ҪӵµĬ·WAN·
  \param[in]  ulBridgeKey: ӦKey
  \return 
  \retval 
*/
VOS_UINT32 ATP_Route6_SupplementDftRouteInMRT(const VOS_CHAR* pszWANInfPath, const VOS_UINT32 ulBridgeKey);

/*!
  \brief LAN󶨽ӿĬϲ·
  \param[in]  pszWANInfPath: Ӳ·ɵWAN Path
  \return 
  \retval VOS_TRUE ִгɹ
  \retval VOS_FALSE ִʧ
*/
VOS_UINT32 ATP_Route6_AddPolicyRoute(const VOS_CHAR* pszWANInfPath);

/*!
  \brief ɾLAN󶨽ӿĬϲ·
  \param[in]  pszWANInfPath: ɾ·ɵWAN Path
  \return 
  \retval VOS_TRUE ִгɹ
  \retval VOS_FALSE ִʧ
*/
VOS_UINT32 ATP_Route6_DelPolicyRoute(const VOS_CHAR* pszWANInfPath);

/*!
  \brief Ϊ·ɰ
  \param[in]  pszInterface: WANӿ
  \param[in]  pszGw: һ
  \param[in]  lBrKey: ӦKey
  \return 
  \retval VOS_TRUE ִгɹ
  \retval VOS_FALSE ִʧ
*/
VOS_UINT32 ATP_Route6_AddPortBind(const VOS_CHAR *pszWanIfc, const VOS_CHAR *pszGateway, const VOS_INT32 lBrKey);

/*!
  \brief Ϊ·ɽ
  \param[in]  lBrKey: ӦKey
  \return 
  \retval VOS_TRUE ִгɹ
  \retval VOS_FALSE ִʧ
*/
VOS_UINT32 ATP_Route6_DelPortBind(const VOS_INT32 lBrKey);

/*!
  \brief LANRADVDDHCP6Sǰ׺ıʱˢ²·ɱ
  \param[in]  ulTableId: Ӧ·ɱ
  \return 
  \retval VOS_TRUE ִгɹ
  \retval VOS_FALSE ִʧ
*/
VOS_VOID ATP_Route6_TableRestart(const VOS_INT32 lBridgeKey);
VOS_UINT32 AddDelL2BPolicyRoute(VOS_VOID * vlBridgeKey,VOS_VOID *pvHook);
VOS_UINT32 AddDelL2BPolicyRouteEx(VOS_VOID * vlBridgeKey,VOS_VOID *pvHook);
VOS_UINT32 ATP_ROUTE6CMS_Init(VOS_VOID);
#ifdef SUPPORT_ATP_TR181
VOS_VOID ROUTE6CMS_StopAll(VOS_UINT32 ulInstId);
VOS_VOID ROUTE6CMS_SetupAll(VOS_UINT32 ulInstId);
VOS_VOID ROUTE6CMS_DelAll(VOS_UINT32 ulInstId);
#endif

#ifdef __cplusplus
#if __cplusplus
}
#endif /* __cpluscplus */
#endif /* __cpluscplus */

#endif
